from tkinter import *
import time
import random
from PIL import Image, ImageTk
import os

tk = Tk()

#canvas and objects variables
skyColor = "turquoise"
groundColor = "yellow"
dinoColor = "green"
cactiColor = "darkgreen"
screenW = 1000
screenH = 300
groundLevel = screenH-20

#Create canvas
tk.geometry(str(screenW) + "x" + str(screenH) + "+0+0")
tk.title("Game")
canvas = Canvas(tk, width=screenW, height=screenH, bg=skyColor)
message = canvas.create_text(screenW/2, screenH/2, text="", fill="white", font=("Purisa", 70))
scoreText = canvas.create_text(50, 50, text="", fill="white", font=("Purisa", 70))
bestScoreText = canvas.create_text(screenW-50, 50, text="", fill="white", font=("Purisa", 70))

canvas.pack()

class Ground:
    def __init__(self, canvas):
        self.canvas = canvas
        self.ground = self.canvas.create_rectangle(0, screenH, screenW, screenH-30, fill=groundColor, outline=groundColor)
    #def move(self):
        #self.canvas.move(self.ground, -10, 0)

class Cacti:
    def __init__(self, canvas):
        self.canvas = canvas
        self.cacti = self.canvas.create_rectangle(screenW, screenH-20, screenW+20, screenH-100, outline="")#, fill=cactiColor, outline=cactiColor)
    def move(self):
        self.canvas.move(self.cacti, -10, 0)
    def getCoords(self):
        return self.canvas.coords(self.cacti)

class Dino:
    def __init__(self, canvas):
        self.jumping = False
        self.chuting = False
        self.canvas = canvas
        self.speed = 21
        self.dino = self.canvas.create_rectangle(screenW/4, groundLevel, screenW/4+20, groundLevel-80, outline="")#, fill=dinoColor, outline=dinoColor)
    def jump(self):
        if self.jumping == True:
            self.speed -= 1
            self.canvas.move(self.dino, 0, -self.speed/2)
            if self.speed <= 0:
                self.speed = 0
                self.jumping = False
                self.chuting = True
    def chute(self):
        if self.chuting == True:
            self.speed += 1
            self.canvas.move(self.dino, 0, self.speed/2)
            if self.speed >= 20:
                self.speed = 21
                self.chuting = False
    def getCoords(self):
        return self.canvas.coords(self.dino)

def jump(event):
    global dinoClass, running
    if dinoClass.jumping == False and dinoClass.chuting == False:
        dinoClass.jumping = True
    running = True

maxsize = (100, 100)

img = Image.open("dino.gif")
img.thumbnail(maxsize, Image.ANTIALIAS)
dino = ImageTk.PhotoImage(img)

img = Image.open("dinoDead.gif")
img.thumbnail(maxsize, Image.ANTIALIAS)
dinoDead = ImageTk.PhotoImage(img)

img = Image.open("cacti.gif")
img.thumbnail(maxsize, Image.ANTIALIAS)
cacti = ImageTk.PhotoImage(img)

ground = Ground(canvas)
dinoClass = Dino(canvas)

bestScore = 0

while True:
    cactiImgMemory = []
    cactiMemory = []
    
    canvas.itemconfigure(message, text="")
    score = 0

    won = True
    oldTime = time.time()
    seed = 3.0
    
    while seed > 1:
        canvas.itemconfigure(scoreText, text=score)
        canvas.itemconfigure(bestScoreText, text=bestScore)
        dinoCoords = dinoClass.getCoords()
        dinoImg = canvas.create_image(dinoCoords[0], dinoCoords[1]+40, image=dino)
        #generator = random.randint(0, int(round(seed)))
        currentTime = time.time()-oldTime
        #print(currentTime)
        if currentTime >= seed:
            seed -= 0.1
            oldTime = time.time()
            item = Cacti(canvas)
            cactiMemory.append(item)
            cactiImgMemory.append(canvas.create_image(item.getCoords()[0], item.getCoords()[1]+40, image=cacti))
        for item in cactiMemory:
            if item.getCoords()[2] > 0:
                item.move()
                sameIndex = cactiMemory.index(item)
                canvas.move(cactiImgMemory[sameIndex], -10, 0)
            else:
                sameIndex = cactiMemory.index(item)
                cactiMemory.remove(item)
                cactiImgMemory.remove(cactiImgMemory[sameIndex])
                score += 1
                if score > bestScore:
                    bestScore = score
        dinoClass.jump()
        dinoClass.chute()
        tk.update_idletasks()
        tk.update()
        for item in cactiMemory:
            killingAreaXborder1 = item.getCoords()[0]-10
            killingAreaXborder2 = item.getCoords()[2]
            killingAreaYborder1 = item.getCoords()[1]-5
            killingAreaYborder2 = item.getCoords()[3]
            if dinoCoords[2] > killingAreaXborder1 and dinoCoords[0] < killingAreaXborder2 and dinoCoords[3] > killingAreaYborder1 and dinoCoords[1] < killingAreaYborder2:
                seed = 0
                won = False
                pass
        tk.bind('<Up>', jump)
        tk.bind('<space>', jump)
        canvas.delete(dinoImg)

    dinoImg = canvas.create_image(dinoCoords[0], dinoCoords[1]+40, image=dino)
    if won == True:
        canvas.itemconfigure(message, text="You won!")
        break
    else:
        dinoDeadImg = canvas.create_image(killingAreaXborder2-20, killingAreaYborder1+5, image=dinoDead)
        running = False
        canvas.itemconfigure(message, text="Game Over!")
        while running == False:
            tk.bind('<Up>', jump)
            tk.bind('<space>', jump)
            tk.update_idletasks()
            tk.update()
        canvas.delete(dinoImg)
        canvas.delete(dinoDeadImg)
        for item in cactiImgMemory:
            canvas.delete(item)
